
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProductsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.create(
            {
                id: data.id || undefined,
        
        sku: data.sku
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        product_type: data.product_type
        ||
        null
            ,
            
        unit: data.unit
        ||
        null
            ,
            
        sale_price: data.sale_price
        ||
        null
            ,
            
        purchase_price: data.purchase_price
        ||
        null
            ,
            
        vat_rate: data.vat_rate
        ||
        null
            ,
            
        low_stock_threshold: data.low_stock_threshold
        ||
        null
            ,
            
        track_stock: data.track_stock
        ||
        false
        
            ,
            
        description: data.description
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await products.setCategory( data.category || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'images',
                belongsToId: products.id,
            },
            data.images,
            options,
        );
        

        return products;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const productsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sku: item.sku
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                product_type: item.product_type
            ||
            null
            ,
            
                unit: item.unit
            ||
            null
            ,
            
                sale_price: item.sale_price
            ||
            null
            ,
            
                purchase_price: item.purchase_price
            ||
            null
            ,
            
                vat_rate: item.vat_rate
            ||
            null
            ,
            
                low_stock_threshold: item.low_stock_threshold
            ||
            null
            ,
            
                track_stock: item.track_stock
            ||
            false
        
            ,
            
                description: item.description
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const products = await db.products.bulkCreate(productsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < products.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.products.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: products[i].id,
                },
                data[i].images,
                options,
            );
        }
        

        return products;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const products = await db.products.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sku !== undefined) updatePayload.sku = data.sku;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.product_type !== undefined) updatePayload.product_type = data.product_type;
        
        
        if (data.unit !== undefined) updatePayload.unit = data.unit;
        
        
        if (data.sale_price !== undefined) updatePayload.sale_price = data.sale_price;
        
        
        if (data.purchase_price !== undefined) updatePayload.purchase_price = data.purchase_price;
        
        
        if (data.vat_rate !== undefined) updatePayload.vat_rate = data.vat_rate;
        
        
        if (data.low_stock_threshold !== undefined) updatePayload.low_stock_threshold = data.low_stock_threshold;
        
        
        if (data.track_stock !== undefined) updatePayload.track_stock = data.track_stock;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await products.update(updatePayload, {transaction});

        
        
        if (data.category !== undefined) {
            await products.setCategory(
              
              data.category,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'images',
                belongsToId: products.id,
            },
            data.images,
            options,
        );
        

        return products;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of products) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of products) {
                await record.destroy({transaction});
            }
        });


        return products;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findByPk(id, options);

        await products.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await products.destroy({
            transaction
        });

        return products;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findOne(
            { where },
            { transaction },
        );

        if (!products) {
            return products;
        }

        const output = products.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.stock_movements_product = await products.getStock_movements_product({
            transaction
        });
        
        
        
        output.quote_items_product = await products.getQuote_items_product({
            transaction
        });
        
        
        
        output.sale_items_product = await products.getSale_items_product({
            transaction
        });
        
        
        
        output.invoice_items_product = await products.getInvoice_items_product({
            transaction
        });
        
        
        
        
        
        
        
        
        output.alerts_product = await products.getAlerts_product({
            transaction
        });
        
        
        
        
        
        output.category = await products.getCategory({
            transaction
        });
        
        
        output.images = await products.getImages({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.categories,
        as: 'category',
        
        where: filter.category ? {
          [Op.or]: [
            { id: { [Op.in]: filter.category.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.category.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.sku) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'sku',
                        filter.sku,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.sale_priceRange) {
                const [start, end] = filter.sale_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sale_price: {
                    ...where.sale_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sale_price: {
                    ...where.sale_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.purchase_priceRange) {
                const [start, end] = filter.purchase_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    purchase_price: {
                    ...where.purchase_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    purchase_price: {
                    ...where.purchase_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.vat_rateRange) {
                const [start, end] = filter.vat_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    vat_rate: {
                    ...where.vat_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    vat_rate: {
                    ...where.vat_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.low_stock_thresholdRange) {
                const [start, end] = filter.low_stock_thresholdRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    low_stock_threshold: {
                    ...where.low_stock_threshold,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    low_stock_threshold: {
                    ...where.low_stock_threshold,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.product_type) {
                where = {
                    ...where,
                product_type: filter.product_type,
            };
            }
            
            if (filter.unit) {
                where = {
                    ...where,
                unit: filter.unit,
            };
            }
            
            if (filter.track_stock) {
                where = {
                    ...where,
                track_stock: filter.track_stock,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.products.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'products',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.products.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

